import okhttp3.Credentials;
import okhttp3.OkHttpClient;
import okhttp3.Request;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.Proxy;

/**
 * Create by ipidea on 2021/6/3
 * <p>
 * compile 'com.squareup.okhttp3:okhttp:3.10.0'
 */
class HttpAuthProxy {
    public static void main(String[] args) throws IOException {
        testWithOkHttp();
    }

    public static void testWithOkHttp() throws IOException {
        String url = "https://api.myip.la/en?json";
        Proxy proxy = new Proxy(Proxy.Type.HTTP, new InetSocketAddress("proxy.ipidea.io", 2333));
        OkHttpClient client = new OkHttpClient().newBuilder().proxy(proxy).proxyAuthenticator((route, response) -> {
            String credential = Credentials.basic("账户-zone-quark-region-kr", "密码");
            return response.request().newBuilder()
                    .header("Proxy-Authorization", credential)
                    .build();
        }).build();


        Request request = new Request.Builder().url(url).build();
        okhttp3.Response response = client.newCall(request).execute();
        String responseString = response.body().string();
        System.out.println(responseString);
    }
}
